/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.enums.EnumScaleLevel;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreMissinglist.TCoreMissinglistPath;
import de.ship.db.tables.TCoreUnit.TCoreUnitPath;
import de.ship.db.tables.TCoreValuelist.TCoreValuelistPath;
import de.ship.db.tables.TCoreVariableattr.TCoreVariableattrPath;
import de.ship.db.tables.TCoreVariableattrtype.TCoreVariableattrtypePath;
import de.ship.db.tables.TDmCalculated.TDmCalculatedPath;
import de.ship.db.tables.TDmVarAdd.TDmVarAddPath;
import de.ship.db.tables.TInputDisplayvar.TInputDisplayvarPath;
import de.ship.db.tables.TInputStaticvars.TInputStaticvarsPath;
import de.ship.db.tables.records.TCoreVariableRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreVariable extends TableImpl<TCoreVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_variable</code>
     */
    public static final TCoreVariable T_CORE_VARIABLE = new TCoreVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreVariableRecord> getRecordType() {
        return TCoreVariableRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_variable.pk_core_variable</code>.
     */
    public final TableField<TCoreVariableRecord, Integer> PK_CORE_VARIABLE = createField(DSL.name("pk_core_variable"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_variable.key_variable</code>.
     */
    public final TableField<TCoreVariableRecord, Integer> KEY_VARIABLE = createField(DSL.name("key_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_variable.fk_var_valuelist</code>.
     */
    public final TableField<TCoreVariableRecord, Integer> FK_VAR_VALUELIST = createField(DSL.name("fk_var_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_variable.fk_missinglist</code>.
     */
    public final TableField<TCoreVariableRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_variable.lastchange</code>.
     */
    public final TableField<TCoreVariableRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_variable.fk_unit</code>.
     */
    public final TableField<TCoreVariableRecord, Integer> FK_UNIT = createField(DSL.name("fk_unit"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_variable.scale_level</code>.
     */
    public final TableField<TCoreVariableRecord, EnumScaleLevel> SCALE_LEVEL = createField(DSL.name("scale_level"), SQLDataType.VARCHAR.asEnumDataType(EnumScaleLevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_variable.data_type</code>.
     */
    public final TableField<TCoreVariableRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    private TCoreVariable(Name alias, Table<TCoreVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreVariable(Name alias, Table<TCoreVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variable</code> table reference
     */
    public TCoreVariable(String alias) {
        this(DSL.name(alias), T_CORE_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variable</code> table reference
     */
    public TCoreVariable(Name alias) {
        this(alias, T_CORE_VARIABLE);
    }

    /**
     * Create a <code>common_dd.t_core_variable</code> table reference
     */
    public TCoreVariable() {
        this(DSL.name("t_core_variable"), null);
    }

    public <O extends Record> TCoreVariable(Table<O> path, ForeignKey<O, TCoreVariableRecord> childPath, InverseForeignKey<O, TCoreVariableRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VARIABLE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreVariablePath extends TCoreVariable implements Path<TCoreVariableRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreVariablePath(Table<O> path, ForeignKey<O, TCoreVariableRecord> childPath, InverseForeignKey<O, TCoreVariableRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreVariablePath(Name alias, Table<TCoreVariableRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreVariablePath as(String alias) {
            return new TCoreVariablePath(DSL.name(alias), this);
        }

        @Override
        public TCoreVariablePath as(Name alias) {
            return new TCoreVariablePath(alias, this);
        }

        @Override
        public TCoreVariablePath as(Table<?> alias) {
            return new TCoreVariablePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_VARIABLE_FK_VAR_VALUELIST);
    }

    @Override
    public Identity<TCoreVariableRecord, Integer> getIdentity() {
        return (Identity<TCoreVariableRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreVariableRecord> getPrimaryKey() {
        return Keys.PK_CORE_VARIABLE;
    }

    @Override
    public List<UniqueKey<TCoreVariableRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_KEY_VARIABLE);
    }

    @Override
    public List<ForeignKey<TCoreVariableRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VARIABLE__FK_KEY_VARIABLE, Keys.T_CORE_VARIABLE__FK_VAR_VALUELIST, Keys.T_CORE_VARIABLE__FK_VAR_MISSINGLIST, Keys.T_CORE_VARIABLE__FK_UNIT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_VARIABLE__FK_KEY_VARIABLE, null);

        return _tCoreElementHierarchy;
    }

    private transient TCoreValuelistPath _tCoreValuelist;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_valuelist</code>
     * table.
     */
    public TCoreValuelistPath tCoreValuelist() {
        if (_tCoreValuelist == null)
            _tCoreValuelist = new TCoreValuelistPath(this, Keys.T_CORE_VARIABLE__FK_VAR_VALUELIST, null);

        return _tCoreValuelist;
    }

    private transient TCoreMissinglistPath _tCoreMissinglist;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_missinglist</code> table.
     */
    public TCoreMissinglistPath tCoreMissinglist() {
        if (_tCoreMissinglist == null)
            _tCoreMissinglist = new TCoreMissinglistPath(this, Keys.T_CORE_VARIABLE__FK_VAR_MISSINGLIST, null);

        return _tCoreMissinglist;
    }

    private transient TCoreUnitPath _tCoreUnit;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_unit</code>
     * table.
     */
    public TCoreUnitPath tCoreUnit() {
        if (_tCoreUnit == null)
            _tCoreUnit = new TCoreUnitPath(this, Keys.T_CORE_VARIABLE__FK_UNIT, null);

        return _tCoreUnit;
    }

    private transient TCoreVariableattrPath _tCoreVariableattr;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variableattr</code> table
     */
    public TCoreVariableattrPath tCoreVariableattr() {
        if (_tCoreVariableattr == null)
            _tCoreVariableattr = new TCoreVariableattrPath(this, null, Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_VARIABLE.getInverseKey());

        return _tCoreVariableattr;
    }

    private transient TDmCalculatedPath _tDmCalculated;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_calculated</code> table
     */
    public TDmCalculatedPath tDmCalculated() {
        if (_tDmCalculated == null)
            _tDmCalculated = new TDmCalculatedPath(this, null, Keys.T_DM_CALCULATED__FK_DM_CALCULATED_VARIABLE.getInverseKey());

        return _tDmCalculated;
    }

    private transient TDmVarAddPath _tDmVarAdd;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_var_add</code> table
     */
    public TDmVarAddPath tDmVarAdd() {
        if (_tDmVarAdd == null)
            _tDmVarAdd = new TDmVarAddPath(this, null, Keys.T_DM_VAR_ADD__FK_VARIABLE_VAR_ADD.getInverseKey());

        return _tDmVarAdd;
    }

    private transient TInputDisplayvarPath _tInputDisplayvar;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_displayvar</code> table
     */
    public TInputDisplayvarPath tInputDisplayvar() {
        if (_tInputDisplayvar == null)
            _tInputDisplayvar = new TInputDisplayvarPath(this, null, Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_VAR.getInverseKey());

        return _tInputDisplayvar;
    }

    private transient TInputStaticvarsPath _tInputStaticvars;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_staticvars</code> table
     */
    public TInputStaticvarsPath tInputStaticvars() {
        if (_tInputStaticvars == null)
            _tInputStaticvars = new TInputStaticvarsPath(this, null, Keys.T_INPUT_STATICVARS__FK_INPUTSTATICVARS_VAR.getInverseKey());

        return _tInputStaticvars;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_variableattrtype</code> table
     */
    public TCoreVariableattrtypePath tCoreVariableattrtype() {
        return tCoreVariableattr().tCoreVariableattrtype();
    }

    @Override
    public TCoreVariable as(String alias) {
        return new TCoreVariable(DSL.name(alias), this);
    }

    @Override
    public TCoreVariable as(Name alias) {
        return new TCoreVariable(alias, this);
    }

    @Override
    public TCoreVariable as(Table<?> alias) {
        return new TCoreVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariable rename(String name) {
        return new TCoreVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariable rename(Name name) {
        return new TCoreVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariable rename(Table<?> name) {
        return new TCoreVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable where(Condition condition) {
        return new TCoreVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
